/*TUG PDS CERT 1.01 (C)

==========================================================================

		  TUG PUBLIC DOMAIN SOFTWARE CERTIFICATION

The Turbo User Group (TUG) is recognized by Borland International as the
official support organization for Turbo languages.  This file has been
compiled and verified by the TUG library staff.  We are reasonably certain
that the information contained in this file is public domain material, but
it is also subject to any restrictions applied by its author.

This diskette contains PROGRAMS and/or DATA determined to be in the PUBLIC
DOMAIN, provided as a service of TUG for the use of its members.  The
Turbo User Group will not be liable for any damages, including any lost
profits, lost savings or other incidental or consequential damages arising
out of the use of or inability to use the contents, even if TUG has been
advised of the possibility of such damages, or for any claim by any
other party.

To the best of our knowledge, the routines in this file compile and function
properly in accordance with the information described below.

If you discover an error in this file, we would appreciate it if you would
report it to us.  To report bugs, or to request information on membership
in TUG, please contact us at:

	     Turbo User Group
	     PO Box 1510
	     Poulsbo, Washington USA  98370

--------------------------------------------------------------------------
		       F i l e    I n f o r m a t i o n

* DESCRIPTION
Source code for the kaleids package.  Note that EGA or VGA is required to
run this program.

* ASSOCIATED FILES
KALEIDS.DOC
KALEIDS.C
KALEIDS.EXE

* CHECKED BY
TAG - 1/18/89

* KEYWORDS
PROGRAM C DOS GRAPHICS EGA
==========================================================================
}*/
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys\timeb.h>


#define TRUE         1
#define FALSE        0
#define ESC          27
#define SFACTOR      1000
#define COLORSCREEN  0xB8000000L  /* Color buffer address */


void main(int argc,char *argv[]);
void Initialize(void);
int  GetChar(void);
int  KeyPressed(void);
void ScrClr(void);
void WriteAt(int row,int col,char *str);
static long TimerTicks(void);



typedef struct {                 /* Screen char struct */
   char
      data,
      attr;
   } CHTYPE;

typedef struct {                 /* Screen memory structure */
   CHTYPE ch[25][80];
   } far *SCREENTYPE;


int X1, Y1, X2, Y2, XV1, YV1, XV2, YV2, HC, XA, YA, XB, YB, chr, chr1;
int i, bc = 1, dely = 0, skipopen = FALSE;
int wid = 4, hgt = 3, bcolor = 0;
int CX = 320, CY = 240, M = 240;
int rect[10],maxX,maxY,height,width,old_col,t_center;
void *gbuffer;
unsigned size;

int Red[MAXCOLORS+1], Green[MAXCOLORS+1], Blue[MAXCOLORS+1];
long dummy = 0;

SCREENTYPE                       /* Screen pointer  */
   scr;

int
   arow = 0,                     /* Absolute row    */
   acol = 0,                     /* Absolute column */
   linth = 1,                    /* Line Thickness */
   linpat = 0;                   /* Line Pattern */

union REGS
   cpu;                          /* CPU registers for int86() */



void main(int argc,char *argv[])
{

	for (i = 1; i < argc; i++)
	{
		chr = *argv[i];
		if (chr < 128)
			if (isdigit(chr))
			{
				dely = ('9' - chr) * SFACTOR;
				skipopen = TRUE;
			}
			else if (toupper(*argv[i]) == 'B')
			{
				bc = 0;
				skipopen = TRUE;
			}
      }

	Initialize();

	while (TRUE)
	{
		cleardevice();

		if (bc)
			setrgbpalette(0, 0, 0, 0);
		for (i = bc; i <= MAXCOLORS; i++)
		{
			Red[i] = random(64);
			Green[i] = random(64);
			Blue[i] = random(64);
			setrgbpalette(i, Red[i], Green[i], Blue[i]);
		}

		X1 = random(M) + 1;
		X2 = random(M) + 1;
		Y1 = random(X1);
		Y2 = random(X2);

		while (random(130) > 1)
		{
			XV1 = random(5) - 2;
			XV2 = random(5) - 2;
			YV1 = random(5) - 2;
			YV2 = random(5) - 2;
			HC = random(16);
			setcolor(HC);

			while (random(30) > 1)
			{
			   XA = X1 * wid / hgt;
			   XB = X2 * wid / hgt;
			   YA = Y1 * wid / hgt;
			   YB = Y2 * wid / hgt;
			   line( (CX+XA), (CY-Y1), (CX+XB), (CY-Y2) );
			   line( (CX-YA), (CY+X1), (CX-YB), (CY+X2) );
			   line( (CX-XA), (CY-Y1), (CX-XB), (CY-Y2) );
			   line( (CX-YA), (CY-X1), (CX-YB), (CY-X2) );
			   line( (CX-XA), (CY+Y1), (CX-XB), (CY+Y2) );
			   line( (CX+YA), (CY-X1), (CX+YB), (CY-X2) );
			   line( (CX+XA), (CY+Y1), (CX+XB), (CY+Y2) );
			   line( (CX+YA), (CY+X1), (CX+YB), (CY+X2) );
			   X1 = (X1 + XV1) % M;
			   Y1 = (Y1 + YV1) % M;
			   X2 = (X2 + XV2) % M;
			   Y2 = (Y2 + YV2) % M;
			   if (dely)
			   {
			   for (i = 1; i < dely; i++)
			   {
			   dummy += i * dely;
			   dummy -= dely;
			   }
			   }
			   if (kbhit())
			   {
			   chr = toupper(getch());
			   if (chr == 'P')
			   {
			   chr=0;
			   while(chr != 'P')
			   {
			   if(kbhit())
			   chr = toupper(getch());
			   if(chr == 'B')
			   {
			   chr = 0;
			   if(bcolor<15) bcolor++;
			   else bcolor=0;
			   setbkcolor(bcolor);
			   }
			   }
			   }
			   else if (chr == ESC)
			   {
			   cleardevice();
			   closegraph();
			   exit(0);
			   }
			   else if (chr == 'C')
			   {
			   cleardevice();
			   break;
			   }
			   else if (chr == 'I')
			   {
			   old_col = getcolor();
			   getimage(maxX/2+width,7*height,maxX-2*width,
			   37*height,gbuffer);
			   setcolor(14);
			   settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
			   setlinestyle(SOLID_LINE,0,THICK_WIDTH);
			   setfillstyle(SOLID_FILL,1);
			   fillpoly(sizeof(rect)/(2*sizeof(int)),rect);
			   outtextxy(t_center,9*height,
			   "Active Keys/Results");
			   outtextxy(t_center,13*height,
			   "i/I Show This Window");
			   outtextxy(t_center,15*height,
			   "b/B Change Background Color");
			   outtextxy(t_center,17*height,
			   "t/T Change Line Thickness");
			   outtextxy(t_center,19*height,
			   "c/C Clear Screen");
			   outtextxy(t_center,21*height,
			   "s/S Change Line Style");
			   outtextxy(t_center,23*height,
			   "p/P Pause (B/B Active During Pause)");
			   outtextxy(t_center,25*height,
			   "0-9 Control Speed");
			   outtextxy(t_center,29*height,
			   "ESC -- End This Idiocy");
			   setlinestyle(SOLID_LINE,0,NORM_WIDTH);
			   line(maxX/2+width,10.5*height,
			   maxX-2*width,10.5*height);
			   getch();
			   putimage(maxX/2+width,7*height,gbuffer,COPY_PUT);
			   setcolor(old_col);
			   break;
			   }
			   else if (chr == 'B')
			   {
			   if(bcolor<15) bcolor++;
			   else bcolor=0;
			   setbkcolor(bcolor);
			   break;
			}
		     else if(chr == 'T')
		   {
			if(linth==1) linth=3;
		else linth = 1;
		setlinestyle(linpat,0xffff,linth);
		}
		else if(chr == 'S')
		{
		if(linpat<4) linpat++;
		else linpat = 0;
		setlinestyle(linpat,0xffff,linth);
		}
		else if (isdigit(chr))
		dely = ('9' - chr) * SFACTOR;

	    }
	 }
     }
  }
//  closegraph();
//  exit(0);
}


void Initialize()
{
long endtime, waittime;
int GraphDriver, GraphMode, lo, hi;


   scr = (SCREENTYPE)((void far *)COLORSCREEN); /* Screen memory pointer */

   randomize();                     /* Randomize random number generator */
   directvideo=1;

   if (! skipopen)
   {
	   ScrClr();

	   WriteAt( 1, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
	   WriteAt( 2, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
	   WriteAt( 3, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
	   WriteAt( 4, 2, "KaleidsKaleidsKaleidsKalĿidsKaleidsKaleidsKaleids");
	   WriteAt( 5, 2, "KaleidsKaleidsKaleidsKal  K A L E I D O S C O P E  idsKaleidsKaleidsKaleids");
	   WriteAt( 6, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
	   WriteAt( 7, 2, "KaleidsKaleidsKaleidsKal  Version 3.6 for EGA/VGA  idsKaleidsKaleidsKaleids");
	   WriteAt( 8, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
	   WriteAt( 9, 2, "KaleidsKaleidsKaleidsKal    Judson D. McClendon    idsKaleidsKaleidsKaleids");
	   WriteAt(10, 2, "KaleidsKaleidsKaleidsKal    Edward V. Aguinaga     idsKaleidsKaleidsKaleids");
	   WriteAt(11, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
	   WriteAt(12, 2, "KaleidsKaleidsKaleidsKal  Press: to:               idsKaleidsKaleidsKaleids");
	   WriteAt(13, 2, "KaleidsKaleidsKaleidsKal     'I' instructions      idsKaleidsKaleidsKaleids");
	   WriteAt(14, 2, "KaleidsKaleidsKaleidsKal     'L' line thickness    idsKaleidsKaleidsKaleids");
	   WriteAt(15, 2, "KaleidsKaleidsKaleidsKal     'S' line style        idsKaleidsKaleidsKaleids");
	   WriteAt(16, 2, "KaleidsKaleidsKaleidsKal     'P' pause             idsKaleidsKaleidsKaleids");
	   WriteAt(17, 2, "KaleidsKaleidsKaleidsKal     'C' clear screen      idsKaleidsKaleidsKaleids");
	   WriteAt(18, 2, "KaleidsKaleidsKaleidsKal     'B' toggle background idsKaleidsKaleidsKaleids");
	   WriteAt(19, 2, "KaleidsKaleidsKaleidsKal '0'-'9' set speed         idsKaleidsKaleidsKaleids");
	   WriteAt(20, 2, "KaleidsKaleidsKaleidsKal  ESCape exit              idsKaleidsKaleidsKaleids");
	   WriteAt(21, 2, "KaleidsKaleidsKaleidsKal any key begin/resume...   idsKaleidsKaleidsKaleids");
	   WriteAt(22, 2, "KaleidsKaleidsKaleidsKalidsKaleidsKaleidsKaleids");
	   WriteAt(23, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
	   WriteAt(24, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
	   WriteAt(25, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");


	   arow = 0;                        /* Move cursor to 0,0 */
	   acol = 0;
	   cpu.h.ah = 2;
	   cpu.h.bh = 0;
	   cpu.h.dh = arow;
	   cpu.h.dl = acol;
	   int86(16, &cpu, &cpu);
	   scr->ch[arow][acol].attr = 0;    /* Set cursor color to black on black */

	   endtime = TimerTicks() + 162;    /* Show title screen about 10 seconds */

	   do
	   {                                /* Kaleidoscope title */

		   waittime = TimerTicks() + 1;      /* Will delay for one clock tick */

		   for (arow = 0; arow < 25; arow++)
			   for (acol = 1; acol < 78; acol++)
				   if (arow < 5 || arow > 20 || acol < 26 || acol > 52)
					   if (!(--scr->ch[arow][acol].attr))
						   scr->ch[arow][acol].attr = 15;

			while (TimerTicks() < waittime);   /* Delay */
		} while((!kbhit()) && TimerTicks() < endtime);

		ScrClr();

		if (chr == ESC) {
			exit(0);
		}

	}

	registerbgidriver(EGAVGA_driver);
	GraphDriver = 0;
	initgraph(&GraphDriver, &GraphMode, "");
	getmoderange(GraphDriver,&lo,&hi);

	if (GraphDriver==EGA)
	{
		CY = hi*75+100;
		if(hi)
		{
			wid = 9;
			hgt = 5;
		}
		else
		{
			wid = 10;
			hgt = 3;
		}

	}
	else if (GraphDriver==EGA64)
	{
		CY = 100;
		wid = 10;
		hgt = 3;
		hi=0;
	}
	else if(GraphDriver!=VGA)
	{
		printf("\nError...Requires EGA or VGA!!!");
		exit(0);
	}
	setgraphmode(hi);
	settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	maxX=getmaxx();
	maxY=getmaxy();
	height = textheight("x");
	width = textwidth("x");
	size = imagesize(maxX/2+width,7*height,maxX-2*width,37*height);
	gbuffer = malloc(size);

    rect[0]=maxX/2+width+1;
    rect[1]=7*height+1;
    rect[2]=maxX-2*width-1;
    rect[3]=7*height+1;
    rect[4]=maxX-2*width-1;
    rect[5]=37*height-1;
    rect[6]=maxX/2+width+1;
    rect[7]=37*height-1;
    rect[8]=maxX/2+width+1;
    rect[9]=7*height+1;
    t_center=maxX-2*width-(((maxX-2*width)-(maxX/2+width))/2);

	M = CY - 1;
}


int GetChar(void)
{
int chr;

	chr = getch();

	return(chr);

}


void ScrClr(void)
{

	clrscr();
}


void WriteAt(int row, int col, char *str)
{
int i, n, x, y, color, lst;


	arow = row - 1;
	acol = col - 1;

	while (*str)
	{
		if (arow > 4 && arow < 21 && acol > 25 && acol < 53)
		{
			color = 15;
		}
		else
		{
			x = abs(39 - acol);
			y = abs(12 - arow);
			n = x*x + y*y;
			lst = n >> 1;
			for (i = 1; i < 5; i++) {
				if (! lst) {
					color = 0;
					break;
				}
				color = (n / lst + lst) >> 1;
				lst = color;
            }
			color = (color % 15) + 1;
		}

		scr->ch[arow][acol].data = *(str++);
		scr->ch[arow][acol].attr = (char)color;
		if (++acol > 79) {
			arow++;
			acol = 0;
		}
	}
}


static long TimerTicks(void)
{
static long ticks;

	cpu.h.ah = 0;
	int86(0x1A, &cpu, &cpu);

	ticks = (((long) cpu.x.cx) << 16) + ((long) cpu.x.dx);
	return(ticks);
}

